Index: pjproject/trunk/pjsip/include/pjsip/sip_tel_uri.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_tel_uri.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_tel_uri.h	(revision 515)
@@ -26,4 +26,11 @@
 
 #include <pjsip/sip_uri.h>
+
+/**
+ * @addtogroup PJSIP_TEL_URI tel URI Scheme
+ * @ingroup PJSIP_URI
+ * @brief Support for "tel:" URI scheme.
+ * @{
+ */
 
 
@@ -69,3 +76,8 @@
 
 
+/**
+ * @}
+ */
+
+
 #endif	/* __PJSIP_TEL_URI_H__ */
Index: pjproject/trunk/pjsip/include/pjsip/sip_transaction.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transaction.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transaction.h	(revision 515)
@@ -32,7 +32,26 @@
 
 /**
- * @defgroup PJSIP_TRANSACT SIP Transaction
+ * @defgroup PJSIP_TRANSACT Transaction Layer
  * @ingroup PJSIP
+ * @brief Provides statefull message processing.
+ *
+ * This module provides stateful processing to incoming or outgoing SIP
+ * messages. 
+ * Before performing any stateful operations, application must register the
+ * transaction layer module by calling #pjsip_tsx_layer_init_module().
+ *
+ * Application should link with <b>pjsip-core</b> library to
+ * use the transaction layer.
+ */
+
+/**
+ * @defgroup PJSIP_TRANSACT_TRANSACTION Transaction
+ * @ingroup PJSIP_TRANSACT
+ * @brief Transaction instance for all types of SIP transactions.
  * @{
+ * The pjsip_transaction describes SIP transaction, and is used for
+ * both INVITE and non-INVITE, UAC or UAS. Application must register the
+ * transaction layer module with #pjsip_tsx_layer_init_module() before
+ * performing any stateful operations.
  */
 
@@ -258,5 +277,5 @@
  */
 PJ_DECL(pj_status_t) pjsip_tsx_terminate( pjsip_transaction *tsx,
-					  int st_code );
+					  int code );
 
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_transport.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 515)
@@ -35,10 +35,15 @@
 
 /**
- * @defgroup PJSIP_TRANSPORT SIP Transport
- * @ingroup PJSIP
- *
- * This is the low-level transport layer. Application normally won't need to 
- * use this function, but instead can use transaction or higher layer API to
- * send and receive messages.
+ * @defgroup PJSIP_TRANSPORT Transport
+ * @ingroup PJSIP_CORE
+ * @brief This is the transport framework.
+ *
+ * The transport framework is fully extensible. Please see
+ * <A HREF="/docs.htm">PJSIP Developer's Guide</A> PDF
+ * document for more information.
+ *
+ * Application MUST register at least one transport to PJSIP before any
+ * messages can be sent or received. Please see @ref PJSIP_TRANSPORT_UDP
+ * on how to create/register UDP transport to the transport framework.
  *
  * @{
@@ -138,6 +143,6 @@
 typedef struct pjsip_rx_data_op_key
 {
-    pj_ioqueue_op_key_t		op_key;
-    pjsip_rx_data	       *rdata;
+    pj_ioqueue_op_key_t		op_key;	/**< ioqueue op_key.		*/
+    pjsip_rx_data	       *rdata;	/**< rdata associated with this */
 } pjsip_rx_data_op_key;
 
@@ -304,7 +309,16 @@
 typedef struct pjsip_tx_data_op_key
 {
+    /** ioqueue pending operation key. */
     pj_ioqueue_op_key_t	    key;
+
+    /** Transmit data associated with this key. */
     pjsip_tx_data	   *tdata;
+
+    /** Arbitrary token (attached by transport) */
     void		   *token;
+
+    /** Callback to be called when pending transmit operation has
+        completed.
+     */
     void		  (*callback)(pjsip_transport*,void*,pj_ssize_t);
 } pjsip_tx_data_op_key;
@@ -377,4 +391,6 @@
     /** Transport manager internal. */
     void		*token;
+
+    /** Callback to be called when this tx_data has been transmitted.	*/
     void	       (*cb)(void*, pjsip_tx_data*, pj_ssize_t);
 
@@ -593,16 +609,16 @@
 struct pjsip_tpfactory
 {
-    /* This list is managed by transport manager. */
+    /** This list is managed by transport manager. */
     PJ_DECL_LIST_MEMBER(struct pjsip_tpfactory);
 
-    pj_pool_t		   *pool;
-    pj_lock_t		   *lock;
-
-    pjsip_transport_type_e  type;
-    char		    type_name[8];
-    unsigned		    flag;
-
-    pj_sockaddr		    local_addr;
-    pjsip_host_port	    addr_name;
+    pj_pool_t		   *pool;	    /**< Owned memory pool.	*/
+    pj_lock_t		   *lock;	    /**< Lock object.		*/
+
+    pjsip_transport_type_e  type;	    /**< Transport type.	*/
+    char		    type_name[8];   /**< Type string name.	*/
+    unsigned		    flag;	    /**< Transport flag.	*/
+
+    pj_sockaddr		    local_addr;	    /**< Bound address.		*/
+    pjsip_host_port	    addr_name;	    /**< Published name.	*/
 
     /**
@@ -629,5 +645,5 @@
  *
  * @param mgr		The transport manager.
- * @param factory	Transport factory.
+ * @param tpf		Transport factory.
  *
  * @return		PJ_SUCCESS if listener was successfully created.
@@ -638,4 +654,9 @@
 /**
  * Unregister factory.
+ *
+ * @param mgr		The transport manager.
+ * @param tpf		Transport factory.
+ *
+ * @return		PJ_SUCCESS is sucessfully unregistered.
  */
 PJ_DECL(pj_status_t) pjsip_tpmgr_unregister_tpfactory(pjsip_tpmgr *mgr,
Index: pjproject/trunk/pjsip/include/pjsip/sip_transport_loop.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport_loop.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport_loop.h	(revision 515)
@@ -20,5 +20,23 @@
 #define __PJSIP_TRANSPORT_LOOP_H__
 
+
+/**
+ * @file sip_transport_loop.h
+ * @brief 
+ * Loopback transport (for debugging)
+ */
+
+
 #include <pjsip/sip_transport.h>
+
+/**
+ * @defgroup PJSIP_TRANSPORT_LOOP Loop Transport
+ * @ingroup PJSIP_TRANSPORT
+ * @brief Loopback transport (for testing purposes).
+ * @{
+ * The loopback transport simply bounce back outgoing messages as
+ * incoming messages. This feature is used mostly during automated
+ * testing, to provide controlled behavior.
+ */
 
 PJ_BEGIN_DECL
@@ -121,4 +139,7 @@
 PJ_END_DECL
 
+/**
+ * @}
+ */
 
 #endif	/* __PJSIP_TRANSPORT_LOOP_H__ */
Index: pjproject/trunk/pjsip/include/pjsip/sip_transport_udp.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport_udp.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport_udp.h	(revision 515)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /* 
  * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
@@ -20,7 +20,21 @@
 #define __PJSIP_TRANSPORT_UDP_H__
 
+/**
+ * @file sip_transport_udp.h
+ * @brief SIP UDP Transport.
+ */
+
 #include <pjsip/sip_transport.h>
 
 PJ_BEGIN_DECL
+
+/**
+ * @defgroup PJSIP_TRANSPORT_UDP UDP transport
+ * @ingroup PJSIP_TRANSPORT
+ * @brief API to create and register UDP transport.
+ * @{
+ * The functions below are used to create UDP transport and register 
+ * the transport to the framework.
+ */
 
 /**
@@ -68,4 +82,7 @@
 PJ_END_DECL
 
+/**
+ * @}
+ */
 
 #endif	/* __PJSIP_TRANSPORT_UDP_H__ */
Index: pjproject/trunk/pjsip/include/pjsip/sip_types.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_types.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_types.h	(revision 515)
@@ -20,14 +20,37 @@
 #define __PJSIP_SIP_TYPES_H__
 
+
+/*
+ * My note: Doxygen PJSIP and PJSIP_CORE group is declared in
+ *          sip_config.h
+ */
+
+/**
+ * @file sip_types.h
+ * @brief Basic PJSIP types.
+ */
+
 #include <pjsip/sip_config.h>
 #include <pj/types.h>
 
 /**
- * Opaque data structure for transports (sip_transport.h).
+ * @addtogroup PJSIP_BASE
+ */
+
+/* @defgroup PJSIP_TYPES Basic Data Types
+ * @ingroup PJSIP_BASE
+ * @brief Basic data types.
+ * @{
+ */
+
+
+
+/**
+ * Forward declaration for SIP transport.
  */
 typedef struct pjsip_transport pjsip_transport;
 
 /**
- * Opaque data type for transport manager (sip_transport.h).
+ * Forward declaration for transport manager.
  */
 typedef struct pjsip_tpmgr pjsip_tpmgr;
@@ -218,4 +241,9 @@
 #define PJSIP_THROW_SPEC(list)
 
+
+/**
+ * @}
+ */
+
 #endif	/* __PJSIP_SIP_TYPES_H__ */
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_ua_layer.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_ua_layer.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_ua_layer.h	(revision 515)
@@ -30,13 +30,24 @@
 
 /**
- * @defgroup PJSUA SIP User Agent Stack
+ * @defgroup PJSIP_UA Base User Agent Layer/Common Dialog Layer
+ * @ingroup PJSIP
+ * @brief Dialog management.
+ *
+ * This module provides basic dialog management, which is used by higher
+ * layer dialog usages such as INVITE sessions and SIP Event Subscription
+ * framework (RFC 3265). Application should link  with <b>pjsip-core</b> 
+ * library to use this base UA layer. The base UA layer module is initialized
+ * with #pjsip_ua_init_module().
  */
 
 /**
  * @defgroup PJSUA_UA SIP User Agent Module
- * @ingroup PJSUA
+ * @ingroup PJSIP_UA
+ * @brief Provides dialog management.
  * @{
- * \brief
- *   User Agent manages the interactions between application and SIP dialogs.
+ *
+ * Application MUST initialize the user agent layer module by calling
+ * #pjsip_ua_init_module() before using any of the dialog API, and link
+ * the application with with <b>pjsip-core</b> library.
  */
 
@@ -44,4 +55,7 @@
 typedef struct pjsip_ua_init_param
 {
+    /** Callback to be called when the UA layer detects that outgoing
+     *  dialog has forked.
+     */
     pjsip_dialog* (*on_dlg_forked)(pjsip_dialog *first_set, pjsip_rx_data *res);
 } pjsip_ua_init_param;
@@ -91,4 +105,9 @@
 
 
+/**
+ * @}
+ */
+
+
 /*
  * Internal (called by sip_dialog.c).
@@ -101,8 +120,4 @@
 
 
-/**
- * @}
- */
-
 PJ_END_DECL
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_uri.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_uri.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_uri.h	(revision 515)
@@ -34,7 +34,13 @@
 
 /**
- * @defgroup PJSIP_URL URL Structures
- * @brief SIP Url, tel: Url, and generic URI.
+ * @defgroup PJSIP_URI URI
+ * @brief URI types and manipulations.
  * @ingroup PJSIP_MSG
+ */
+
+/**
+ * @addtogroup PJSIP_URI_PARAM URI Parameter Container
+ * @ingroup PJSIP_URI
+ * @brief Generic parameter elements container.
  * @{
  */
@@ -118,4 +124,15 @@
 					 const pj_cis_t *pvalue_unres,
 					 int sep);
+
+/**
+ * @}
+ */
+
+/**
+ * @defgroup PJSIP_URI_GENERIC Generic URI
+ * @ingroup PJSIP_URI
+ * @brief Generic representation for all types of URI.
+ * @{
+ */
 
 /**
@@ -220,4 +237,83 @@
 #define PJSIP_URI_SCHEME_IS_TEL(url)	\
     (pj_strnicmp2(pjsip_uri_get_scheme(url), "tel", 3)==0)
+
+
+/**
+ * Generic function to get the URI scheme.
+ * @param uri	    the URI object.
+ * @return	    the URI scheme.
+ */
+PJ_INLINE(const pj_str_t*) pjsip_uri_get_scheme(const void *uri)
+{
+    return (*((pjsip_uri*)uri)->vptr->p_get_scheme)(uri);
+}
+
+/**
+ * Generic function to get the URI object contained by this URI, or the URI 
+ * itself if it doesn't contain another URI.
+ *
+ * @param uri	    the URI.
+ * @return	    the URI.
+ */
+PJ_INLINE(void*) pjsip_uri_get_uri(void *uri)
+{
+    return (*((pjsip_uri*)uri)->vptr->p_get_uri)(uri);
+}
+
+/**
+ * Generic function to compare two URIs.
+ *
+ * @param context   Comparison context.
+ * @param uri1	    The first URI.
+ * @param uri2	    The second URI.
+ * @return	    PJ_SUCCESS if equal, or otherwise the error status which
+ *		    should point to the mismatch part.
+ */
+PJ_INLINE(pj_status_t) pjsip_uri_cmp(pjsip_uri_context_e context, 
+				     const void *uri1, const void *uri2)
+{
+    return (*((const pjsip_uri*)uri1)->vptr->p_compare)(context, uri1, uri2);
+}
+
+/**
+ * Generic function to print an URI object.
+ *
+ * @param context   Print context.
+ * @param uri	    The URI to print.
+ * @param buf	    The buffer.
+ * @param size	    Size of the buffer.
+ * @return	    Length printed.
+ */
+PJ_INLINE(int) pjsip_uri_print(pjsip_uri_context_e context,
+			       const void *uri,
+			       char *buf, pj_size_t size)
+{
+    return (*((const pjsip_uri*)uri)->vptr->p_print)(context, uri, buf, size);
+}
+
+/**
+ * Generic function to clone an URI object.
+ *
+ * @param pool	    Pool.
+ * @param uri	    URI to clone.
+ * @return	    New URI.
+ */
+PJ_INLINE(void*) pjsip_uri_clone( pj_pool_t *pool, const void *uri )
+{
+    return (*((const pjsip_uri*)uri)->vptr->p_clone)(pool, uri);
+}
+
+
+
+/**
+ * @}
+ */
+
+/**
+ * @defgroup PJSIP_SIP_URI SIP URI Scheme and Name address
+ * @ingroup PJSIP_URI
+ * @brief SIP URL structure ("sip:" and "sips:")
+ * @{
+ */
 
 
@@ -262,70 +358,4 @@
 
 /**
- * Generic function to get the URI scheme.
- * @param uri	    the URI object.
- * @return	    the URI scheme.
- */
-PJ_INLINE(const pj_str_t*) pjsip_uri_get_scheme(const void *uri)
-{
-    return (*((pjsip_uri*)uri)->vptr->p_get_scheme)(uri);
-}
-
-/**
- * Generic function to get the URI object contained by this URI, or the URI 
- * itself if it doesn't contain another URI.
- *
- * @param uri	    the URI.
- * @return	    the URI.
- */
-PJ_INLINE(void*) pjsip_uri_get_uri(void *uri)
-{
-    return (*((pjsip_uri*)uri)->vptr->p_get_uri)(uri);
-}
-
-/**
- * Generic function to compare two URIs.
- *
- * @param context   Comparison context.
- * @param uri1	    The first URI.
- * @param uri2	    The second URI.
- * @return	    PJ_SUCCESS if equal, or otherwise the error status which
- *		    should point to the mismatch part.
- */
-PJ_INLINE(pj_status_t) pjsip_uri_cmp(pjsip_uri_context_e context, 
-				     const void *uri1, const void *uri2)
-{
-    return (*((const pjsip_uri*)uri1)->vptr->p_compare)(context, uri1, uri2);
-}
-
-/**
- * Generic function to print an URI object.
- *
- * @param context   Print context.
- * @param uri	    The URI to print.
- * @param buf	    The buffer.
- * @param size	    Size of the buffer.
- * @return	    Length printed.
- */
-PJ_INLINE(int) pjsip_uri_print(pjsip_uri_context_e context,
-			       const void *uri,
-			       char *buf, pj_size_t size)
-{
-    return (*((const pjsip_uri*)uri)->vptr->p_print)(context, uri, buf, size);
-}
-
-/**
- * Generic function to clone an URI object.
- *
- * @param pool	    Pool.
- * @param uri	    URI to clone.
- * @return	    New URI.
- */
-PJ_INLINE(void*) pjsip_uri_clone( pj_pool_t *pool, const void *uri )
-{
-    return (*((const pjsip_uri*)uri)->vptr->p_clone)(pool, uri);
-}
-
-
-/**
  * Create new SIP URL and initialize all fields with zero or NULL.
  * @param pool	    The pool.
@@ -345,4 +375,5 @@
  * Initialize SIP URL (all fields are set to NULL or zero).
  * @param url	    The URL.
+ * @param secure    Create sips URI?
  */
 PJ_DECL(void)  pjsip_sip_uri_init(pjsip_sip_uri *url, int secure);
Index: pjproject/trunk/pjsip/include/pjsip/sip_util.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_util.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_util.h	(revision 515)
@@ -26,6 +26,7 @@
 
 /**
- * @defgroup PJSIP_ENDPT SIP Endpoint
- * @ingroup PJSIP
+ * @defgroup PJSIP_ENDPT_STATELESS Message Creation and Stateless Operations
+ * @ingroup PJSIP_CORE_CORE
+ * @brief Utilities to create various messages and base function to send messages.
  * @{
  */
@@ -239,4 +240,8 @@
  * @param endpt	    The endpoint instance.
  * @param tdata	    The transmit data to be sent.
+ * @param token	    Arbitrary token to be given back on the callback.
+ * @param cb	    Optional callback to notify transmission status (also
+ *		    gives chance for application to discontinue retrying
+ *		    sending to alternate address).
  *
  * @return	    PJ_SUCCESS, or the appropriate error code.
@@ -350,4 +355,14 @@
 						   const pjsip_msg_body *body);
 						    
+/**
+ * @}
+ */
+
+/**
+ * @defgroup PJSIP_TRANSACT_UTIL Stateful Operations
+ * @ingroup PJSIP_TRANSACT
+ * @brief Utility function to send requests/responses statefully.
+ * @{
+ */
 
 /**
Index: pjproject/trunk/pjsip/include/pjsip_simple.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip_simple.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip_simple.h	(revision 515)
@@ -19,5 +19,6 @@
 
 /**
- * @defgroup PJSIP_SIMPLE SIP Event, Instant Messaging and Presence Extension (SIMPLE)
+ * @defgroup PJSIP_SIMPLE Event and Presence Framework
+ * @ingroup PJSIP
  */
 
